--
-- Smack, a structured macro language for WoW
-- Author: Zlodo (Taliriah-Silvermoon EU)
--
local _, smack = ...

local recycleBin = {}

function smack.CreateMacroFrame( ... )
    if #recycleBin == 0 then
        return smack.MacroFrame:new( ... )
    end

    local mf = recycleBin[#recycleBin]
    recycleBin[#recycleBin] = nil

    mf:reuse( ... )
    return mf
end

function smack.ReleaseMacroFrame( mf, ... )
    if not mf or mf.empty then
        return
    end
    mf:release( ... )
    recycleBin[#recycleBin + 1] = mf
end
