--
-- Smack, a structured macro language for WoW
-- Author: Zlodo (Taliriah-Silvermoon EU)
--
local _, smack = ...
Smack_Main = smack

smack.CacheClearedEvent = {}

local initFinished = false
smack.AddListener( smack.initFinishedEvent, "Smack_Main",
    function()
        initFinished = true
        smack.Raise( smack.CacheClearedEvent )
    end )

SmackDB =
{
    Macros = {}
}

local mainFrame = CreateFrame( "frame" )

-- Event handling helper
local events = {}
smack.Events = events

mainFrame:SetScript( "OnEvent", function( _, e, ... )
    events[e]( ... )
end )

local function setEventHandler( _, name, func )
    rawset( events, name, func )
    mainFrame:RegisterEvent( name )
end

setmetatable( events, { __newindex = setEventHandler } )
----------------------------

-- Init
function events.PLAYER_ENTERING_WORLD( isInitialLogin, isReload )
    if not isInitialLogin and not isReload then
        return
    end

    SmackDB = SmackDB or {}
    SmackDB.Macros = SmackDB.Macros or {}

    smack.InitCache()
    smack.InitMacros()
    smack.InitConditionals()
end

local function GetUI()
    if not IsAddOnLoaded( "Smack_UI" ) then
        EnableAddOn( "Smack_UI" )
        LoadAddOn( "Smack_UI" )
    end

    return _G["Smack_UI"]
end

local function GetUIIfLoaded()
    if IsAddOnLoaded( "Smack_UI" ) then
        return _G["Smack_UI"]
    end
end

SLASH_SMACKK1 = '/smackk'
function SlashCmdList.SMACKK( arg )
    if arg == "" or arg == "show" or arg == "ui" then
        local ui = GetUI()
        if initFinished then
            ui.Show()
        else
            smack.AddListener( smack.initFinishedEvent, "SmackSlashCommand",
                function() ui.Show() end )
        end
    elseif arg == "hide" then
        local ui = GetUI()
        ui.Hide()
    elseif arg == "clearcache" then
        initFinished = false
        local ui = GetUIIfLoaded()
        if ui then
            ui.Hide()
        end

        SmackDB.CacheClearTime = nil
        smack.ClearCache()
        smack.InitMacros()
    end
end
