--
-- Smack, a structured macro language for WoW
-- Author: Zlodo (Taliriah-Silvermoon EU)
--
-- Slot specification.
--
-- It's just a bunch of literals so that we can
-- avoid writing things like "/use 14" like cavemen
--
local _, compiler = ...

local slotLiteralsInfos = { compiler.SyntaxColor.Literal, completionContext = { slot=1 } }

function compiler.SetupSlotLiterals( parser )
    parser:registerPrefixRule( "Head", slotLiteralsInfos,
        function( p, _, tok )
            p:pushValue( { "slot", tok[2], compiler.CFG.ExprOpCodes.Constant, 1 } )
            return true
        end
    )

    parser:registerPrefixRule( "Neck", slotLiteralsInfos,
        function( p, _, tok )
            p:pushValue( { "slot", tok[2], compiler.CFG.ExprOpCodes.Constant, 2 } )
            return true
        end
    )

    parser:registerPrefixRule( "Shoulder", slotLiteralsInfos,
        function( p, _, tok )
            p:pushValue( { "slot", tok[2], compiler.CFG.ExprOpCodes.Constant, 3 } )
            return true
        end
    )

    parser:registerPrefixRule( "Body", slotLiteralsInfos,
        function( p, _, tok )
            p:pushValue( { "slot", tok[2], compiler.CFG.ExprOpCodes.Constant, 4 } )
            return true
        end
    )

    parser:registerPrefixRule( "Chest", slotLiteralsInfos,
        function( p, _, tok )
            p:pushValue( { "slot", tok[2], compiler.CFG.ExprOpCodes.Constant, 5 } )
            return true
        end
    )

    parser:registerPrefixRule( "Waist", slotLiteralsInfos,
        function( p, _, tok )
            p:pushValue( { "slot", tok[2], compiler.CFG.ExprOpCodes.Constant, 6 } )
            return true
        end
    )

    parser:registerPrefixRule( "Legs", slotLiteralsInfos,
        function( p, _, tok )
            p:pushValue( { "slot", tok[2], compiler.CFG.ExprOpCodes.Constant, 7 } )
            return true
        end
    )

    parser:registerPrefixRule( "Feet", slotLiteralsInfos,
        function( p, _, tok )
            p:pushValue( { "slot", tok[2], compiler.CFG.ExprOpCodes.Constant, 8 } )
            return true
        end
    )

    parser:registerPrefixRule( "Wrist", slotLiteralsInfos,
        function( p, _, tok )
            p:pushValue( { "slot", tok[2], compiler.CFG.ExprOpCodes.Constant, 9 } )
            return true
        end
    )

    parser:registerPrefixRule( "Hand", slotLiteralsInfos,
        function( p, _, tok )
            p:pushValue( { "slot", tok[2], compiler.CFG.ExprOpCodes.Constant, 10 } )
            return true
        end
    )

    parser:registerPrefixRule( "Finger1", slotLiteralsInfos,
        function( p, _, tok )
            p:pushValue( { "slot", tok[2], compiler.CFG.ExprOpCodes.Constant, 11 } )
            return true
        end
    )

    parser:registerPrefixRule( "Finger2", slotLiteralsInfos,
        function( p, _, tok )
            p:pushValue( { "slot", tok[2], compiler.CFG.ExprOpCodes.Constant, 12 } )
            return true
        end
    )

    parser:registerPrefixRule( "Trinket1", slotLiteralsInfos,
        function( p, _, tok )
            p:pushValue( { "slot", tok[2], compiler.CFG.ExprOpCodes.Constant, 13 } )
            return true
        end
    )

    parser:registerPrefixRule( "Trinket2", slotLiteralsInfos,
        function( p, _, tok )
            p:pushValue( { "slot", tok[2], compiler.CFG.ExprOpCodes.Constant, 14 } )
            return true
        end
    )

    parser:registerPrefixRule( "Back", slotLiteralsInfos,
        function( p, _, tok )
            p:pushValue( { "slot", tok[2], compiler.CFG.ExprOpCodes.Constant, 15 } )
            return true
        end
    )

    parser:registerPrefixRule( "MainHand", slotLiteralsInfos,
        function( p, _, tok )
            p:pushValue( { "slot", tok[2], compiler.CFG.ExprOpCodes.Constant, 16 } )
            return true
        end
    )

    parser:registerPrefixRule( "OffHand", slotLiteralsInfos,
        function( p, _, tok )
            p:pushValue( { "slot", tok[2], compiler.CFG.ExprOpCodes.Constant, 17 } )
            return true
        end
    )
end
