--
-- Smack, a structured macro language for WoW
-- Author: Zlodo (Taliriah-Silvermoon EU)
--
-- The either statement.
--
local _, compiler = ...

local function eitherPredicate( p )
    return not p.inEitherBlock
end

function compiler.SetupEitherStatement( parser )
    local eitherInfos =
    {
        compiler.SyntaxColor.ControlStmt,
        shouldIndent = true,
        completionPredicate = eitherPredicate
    }

    compiler.createStatement( parser, "either", eitherInfos,
        function( p, _, tok )
            if p.inEitherBlock then
                p.context:error( tok[2], "Either blocks can't be nested." )
                p.context:poison()
                return {}
            end

            p.scopeStack:push()
            p.inEitherBlock = true
            local ok = p:parseExpr( compiler.Precedence.Statement )
            p.inEitherBlock = false
            p.scopeStack:pop()

            return ok
        end
    )
end
