--
-- Smack, a structured macro language for WoW
-- Author: Zlodo (Taliriah-Silvermoon EU)
--
local _, ui = ...
local zu = ui.zu

local AboutClass = {}
ui.AboutClass = AboutClass
setmetatable( AboutClass, { __index = zu.CompositeClass } )

function AboutClass:new()
    local o = {}
    setmetatable( o, { __index = self } )
    return o
end

function ui.AboutPane()
    return AboutClass:new()
end

function AboutClass:create( parentFrame )
    if not self.content then
        local smackVersion = GetAddOnMetadata( "Smack", "Version" )

        self.content = zu.OverlayLayout
        {
            zu.VerticalLayout
            {
                zu.Spacer { minH = 1 },
                ui.Logo(),
                zu.Text
                {
                    text = "Version " .. smackVersion .. "\nby Zlodo (|cfffef367Taliriah|r-Silvermoon\194\160EU)",
                    justify = "CENTER"
                },
                zu.InlineTextView
                {
                    text = "https://zlodo.cc/smack",
                    doubleClickSelectsAll = true
                },
                zu.Spacer { minH = 1 },
            },

            zu.Filler
            {
                0.05, 0, 0.125, 1
            }
        }

        self.content.parent = self
    end

    self.content:create( parentFrame )
end
