--
-- Smack, a structured macro language for WoW
-- Author: Zlodo (Taliriah-Silvermoon EU)
--
local _, ui = ...
local zu = ui.zu

local MacroHelp = {}
ui.MacroHelp = MacroHelp
setmetatable( MacroHelp, { __index = zu.PopupClass } )

MacroHelp.apparitionDelay = 0
MacroHelp.style = "dropdown"
MacroHelp.channel = "completion"

function MacroHelp:new( editor )
    local o = {}

    o.editor = editor
    o.content = zu.Text {}

    setmetatable( o, { __index = self } )
    return o
end

function MacroHelp:setText( text )
    self.content:setText( text )
end

function MacroHelp:show( l, c )
    local x, y = self.editor:lineColToCoords( l, c )
    zu.PopupClass.show( self, x, y, self.editor.view.frame )
    self.editor:attachPopup( self )
end

function MacroHelp:hide()
    self.editor:detachPopup( self )
    zu.PopupClass.hide( self )
end
