--
-- Smack, a structured macro language for WoW
-- Author: Zlodo (Taliriah-Silvermoon EU)
--
local _, addon = ...
addon.zu = addon.zu or {}
local zu = addon.zu

local PlusClass = {}
zu.PlusClass = PlusClass
setmetatable( PlusClass, { __index = zu.CompositeClass } )

function PlusClass:new( tpl )
    local o = {}
    setmetatable( tpl, { __index = self } )
    setmetatable( o, { __index = tpl } )
    return o
end

function zu.Plus( tpl )
    return PlusClass:new( tpl )
end

function PlusClass:create( parentFrame )
    if not self.content then
        self.textWidget = zu.Text
        {
            text = self.text,
            justify = "LEFT"
        }

        self.content = zu.HorizontalLayout
        {
            zu.Icon
            {
                icon = "plus",
                color = { 0.1, 1, 0.2, 1 },
            },

            self.textWidget
        }

        if self.minimize then
            self.content = zu.Minimize { content = self.content }
        end

        self.content.parent = self
    end

    self.content:create( parentFrame )
end

function PlusClass:setText( text )
    self.text = text
    if self.textWidget then
        self.textWidget:setText( text )
    end
end
