--
-- Smack, a structured macro language for WoW
-- Author: Zlodo (Taliriah-Silvermoon EU)
--
local _, addon = ...
addon.zu = addon.zu or {}
local zu = addon.zu

local WarningClass = {}
zu.WarningClass = WarningClass
setmetatable( WarningClass, { __index = zu.CompositeClass } )

function WarningClass:new( tpl )
    local o = {}
    setmetatable( tpl, { __index = self } )
    setmetatable( o, { __index = tpl } )
    return o
end

function zu.Warning( tpl )
    return WarningClass:new( tpl )
end

function WarningClass:create( parentFrame )
    if not self.content then
        self.content = zu.HorizontalLayout
        {
            zu.Icon
            {
                icon = "warning",
                color = { 1, 0.8, 0, 1 },
            },

            zu.Text
            {
                text = self.text,
                justify = "LEFT"
            },
        }

        if self.minimize then
            self.content = zu.Minimize { content = self.content }
        end

        self.content.parent = self
    end

    self.content:create( parentFrame )
end

function WarningClass:setText( text )
    self.text = text
    if self.content then
        self.content[2]:setText( text )
    end
end
