--
-- Zlodo's UI framework
-- Author: Zlodo (Taliriah-Silvermoon EU)
--
-- Base class group widgets.
--
local _, addon = ...
addon.zu = addon.zu or {}
local zu = addon.zu

local GroupClass = {}
zu.GroupClass = GroupClass
setmetatable( GroupClass, { __index = zu.Widget } )

function GroupClass:new( tpl )
    local o = {}
    setmetatable( tpl, { __index = self } )
    setmetatable( o, { __index = tpl } )
    return o
end

function GroupClass:release()
    for i=1, self.numElements, 1 do
        local v = self[i]
        v:release()
    end

    self.numElements = 0
end

function GroupClass:reuse()
    for i=1, self.numElements, 1 do
        local v = self[i]
        if v then
            v:reuse()
        end
    end
end

function GroupClass:show()
    self.shown = true

    for i=1, self.numElements, 1 do
        local v = self[i]
        v:show()
    end
end

function GroupClass:hide()
    self.shown = false

    for i=1, self.numElements, 1 do
        local v = self[i]
        v:hide()
    end
end

function GroupClass:freeze()
    for i=1, self.numElements, 1 do
        local v = self[i]
        v:freeze()
    end
end

function GroupClass:unfreeze()
    for i=1, self.numElements, 1 do
        local v = self[i]
        v:unfreeze()
    end
end
