--
-- Zlodo's UI framework
-- Author: Zlodo (Taliriah-Silvermoon EU)
--
-- A class that forces its contained element to its min size.
--
local _, addon = ...
addon.zu = addon.zu or {}
local zu = addon.zu

local MinimizeClass = {}
zu.MinimizeClass = MinimizeClass
setmetatable( MinimizeClass, { __index = zu.CompositeClass } )

function MinimizeClass:new( tpl )
    local o = {}
    setmetatable( tpl, { __index = self } )
    setmetatable( o, { __index = tpl } )
    return o
end

function zu.Minimize( tpl )
    return MinimizeClass:new( tpl )
end

function MinimizeClass:create( parentFrame )
    self.content.parent = self
    self.content:create( parentFrame )
end

function MinimizeClass:calcMinMax()
    zu.CompositeClass.calcMinMax( self )
    self.maxWidth = self.minWidth
    self.maxHeight = self.minHeight
end

function MinimizeClass:heightForWidth()
    local hfw = self.content:heightForWidth( self.minWidth )
    self.hfw = hfw
    return hfw
end
