--
-- Zlodo's UI framework
-- Author: Zlodo (Taliriah-Silvermoon EU)
--
local _, addon = ...
addon.zu = addon.zu or {}
local zu = addon.zu

local SpacerClass = {}
zu.SpacerClass = SpacerClass
setmetatable( SpacerClass, { __index = zu.Widget } )

-- Default values, can be overriden by the template or inside individual instances
SpacerClass.minW = 32
SpacerClass.minH = 32
SpacerClass.preferredW = 32
SpacerClass.preferredH = 32

function SpacerClass:new( tpl )
    local o = {}
    setmetatable( tpl, { __index = self } )
    setmetatable( o, { __index = tpl } )
    return o
end

function zu.Spacer( tpl )
    return SpacerClass:new( tpl )
end

function SpacerClass:calcMinMax()
    local w = self.matchSizeOf
    if w then
        w:calcMinMax()
        self.minWidth = w.minWidth
        self.maxWidth = w.maxWidth
        self.preferredWidth = w.preferredWidth

        self.minHeight = w.minHeight
        self.maxHeight = w.maxHeight
        self.preferredHeight = w.preferredHeight
        return
    end

    self.minWidth = zu.Scale( self.minW )
    self.maxWidth = self.maxW and zu.Scale( self.maxW ) or nil
    self.preferredWidth = zu.Scale( self.preferredW )
    self.minHeight = zu.Scale( self.minH )
    self.maxHeight = self.maxH and zu.Scale( self.maxH ) or nil
    self.preferredHeight = zu.Scale( self.preferredH )

    w = self.matchWidthOf
    if w then
        w:calcMinMax()
        self.minWidth = w.minWidth
        self.maxWidth = w.maxWidth
        self.preferredWidth = w.preferredWidth
    end

    w = self.matchHeightOf
    if w then
        w:calcMinMax()
        self.minHeight = w.minHeight
        self.maxHeight = w.maxHeight
        self.preferredHeight = w.preferredHeight
        return
    end
end

function SpacerClass:create()
end

function SpacerClass:show()
end

function SpacerClass:hide()
end
