--
-- Zlodo's UI framework
-- Author: Zlodo (Taliriah-Silvermoon EU)
--
local _, addon = ...
addon.zu = addon.zu or {}
local zu = addon.zu

local DefaultLabelDecoratorClass = {}
zu.DefaultLabelDecoratorClass = DefaultLabelDecoratorClass

function DefaultLabelDecoratorClass:new( label )
    local o = {}
    o.label = label
    o.font = zu.DefaultSkin.fontNormal
    setmetatable( o, { __index = self } )
    return o
end

function DefaultLabelDecoratorClass:apply()
    local label = self.label
    self.frame = label.frame
    self.text = label.text
end

function DefaultLabelDecoratorClass:calcMinMax()
    -- Work around the fact that FontString objects annoyingly return a size of 0
    -- for an empty string
    if self.label.label == "" then
        self.text:SetText( "W" )
    end

    self.text:SetTextScale( zu.ContentScaleFactor() )

    self.label.minWidth = self.label.minWidthOverride and zu.Scale( self.label.minWidthOverride ) or self.text:GetUnboundedStringWidth()
    self.label.minHeight = self.text:GetStringHeight() + zu.Scale( 2 )
    self.label.maxHeight = self.label.minHeight

    self.label.preferredWidth = self.label.minWidth + zu.Scale( 32 )
    self.label.preferredHeight = self.label.minHeight
    self.label.levelRange = 1

    if self.label.label == "" then
        self.text:SetText( "" )
    end
end

function DefaultLabelDecoratorClass:heightForWidth()
end

function DefaultLabelDecoratorClass:setLevel( level )
    self.frame:SetFrameLevel( level )
end

function DefaultLabelDecoratorClass:layout( x, y, width, height )
    self.frame:SetSize( width, height )
    self.frame:SetPoint( "TOPLEFT", self.frame:GetParent(), "TOPLEFT", x, -y - zu.Scale( 1 ) )
end
