--
-- Zlodo's UI framework
-- Author: Zlodo (Taliriah-Silvermoon EU)
--
local _, addon = ...
addon.zu = addon.zu or {}
local zu = addon.zu

local DefaultSashDecoratorClass = {}
zu.DefaultSashDecoratorClass = DefaultSashDecoratorClass

function DefaultSashDecoratorClass.SashSize()
    return 3
end

local function onHover( sash, hover )
    local size

    if hover then
        sash.tex:SetColorTexture( 0.58, 0.3, 1 )
        size = zu.Scale( 3 )
    else
        sash.tex:SetColorTexture( 0.4, 0, 1, 1 )
        size = zu.Scale( 1 )
    end

    if sash.vertical then
        sash.tex:SetWidth( size )
    else
        sash.tex:SetHeight( size )
    end
end

function DefaultSashDecoratorClass:new( sash )
    local o = {}
    o.sash = sash

    local tex = sash:CreateTexture( nil, "BACKGROUND" )
    sash.tex = tex
    tex:SetColorTexture( 0.4, 0, 1, 1 )
    sash.onHover = onHover

    if sash.vertical then
        tex:SetPoint( "TOP", sash, "TOP", 0, 0 )
        tex:SetPoint( "BOTTOM", sash, "BOTTOM", 0, 0 )
        tex:SetWidth( zu.Scale( 1 ) )
    else
        tex:SetPoint( "LEFT", sash, "LEFT", 0, 0 )
        tex:SetPoint( "RIGHT", sash, "RIGHT", 0, 0 )
        tex:SetHeight( zu.Scale( 1 ) )
    end

    setmetatable( o, { __index = self } )
    return o
end

function DefaultSashDecoratorClass:layout()
    if self.sash.vertical then
        self.sash.tex:SetWidth( zu.Scale( 1 ) )
    else
        self.sash.tex:SetHeight( zu.Scale( 1 ) )
    end
end
