--
-- Zlodo's UI framework
-- Author: Zlodo (Taliriah-Silvermoon EU)
--
local _, addon = ...
addon.zu = addon.zu or {}
local zu = addon.zu

local DefaultSliderDecoratorClass = {}
zu.DefaultSliderDecoratorClass = DefaultSliderDecoratorClass

function DefaultSliderDecoratorClass:new( slider )
    local o = {}
    o.slider = slider
    setmetatable( o, { __index = self } )
    return o
end

local function update( self )
    if self.hover or self.slider.isDragging then
        self.slider.ktex:SetColorTexture( 0.4, 0, 1, 0.8 )
    else
        self.slider.ktex:SetColorTexture( 0.4, 0, 1, 0.5 )
    end
end

function DefaultSliderDecoratorClass:release()
    self.hover = self.slider.kFrame:IsMouseOver()
    update( self )
end

function DefaultSliderDecoratorClass:apply()
    local slider = self.slider

    slider.ktex:SetColorTexture( 0.4, 0, 1, 0.5 )

    zu.AddListener( slider.endDraggingEvent, self, update )

    slider.kFrame:SetScript( "OnEnter", function()
        self.hover = true
        update( self )
    end )

    slider.kFrame:SetScript( "OnLeave", function()
        self.hover = false
        update( self )
    end )

    if slider.bgtex then
        slider.bgtex:SetColorTexture( 0.05, 0, 0.125 )
    end
end
