--
-- Zlodo's UI framework
-- Author: Zlodo (Taliriah-Silvermoon EU)
--
local _, addon = ...
addon.zu = addon.zu or {}
local zu = addon.zu

local DefaultTextDecoratorClass = {}
zu.DefaultTextDecoratorClass = DefaultTextDecoratorClass

function DefaultTextDecoratorClass:new( text )
    local o = {}
    o.text = text
    setmetatable( o, { __index = self } )
    return o
end

function DefaultTextDecoratorClass:apply()
    local text = self.text
    self.textFrame = text.textFrame
    self.textFrame:SetFontObject( zu.DefaultSkin.fontNormal )
end

function DefaultTextDecoratorClass:calcMinMax()
    self.text.minWidth = min( zu.Scale( 192 ), self.textFrame:GetUnboundedStringWidth() )
    self.text.minHeight = ceil( self.textFrame:GetLineHeight() )
    self.text.maxHeight = self.text.minHeight

    self.text.preferredWidth = self.text.minWidth + zu.Scale( 64 )
    self.text.preferredHeight = self.text.minHeight
    self.text.levelRange = 1
end

function DefaultTextDecoratorClass:getFontObject()
    return zu.DefaultSkin.fontNormal
end
