--
-- Zlodo's UI framework
-- Author: Zlodo (Taliriah-Silvermoon EU)
--
-- A widget representing a tag in the tag editor.
--
local _, addon = ...
addon.zu = addon.zu or {}
local zu = addon.zu

local TagEditorItemClass = {}
zu.TagEditorItemClass = TagEditorItemClass
setmetatable( TagEditorItemClass, { __index = zu.CompositeClass } )

function TagEditorItemClass:new( tpl )
    local o = {}
    setmetatable( tpl, { __index = self } )
    setmetatable( o, { __index = tpl } )
    return o
end

local buttonTpl =
{
    type = "delete",
}

local labelTpl = {}

function TagEditorItemClass:release()
    self:hide()
end

function TagEditorItemClass:reuse()
end

function TagEditorItemClass:create( parentFrame )
    self.model = self.owner.model

    if not self.content then
        local button = zu.Button( buttonTpl )

        button.onClick = function()
            self.model:remove( self.tag )
        end

        self.label = zu.Label( labelTpl )

        self.content = zu.Minimize
        {
            content = zu.HorizontalLayout
            {
                hspacing = 1,
                vspacing = 1,
                button,
                self.label
            }
        }

        self.content.parent = self
        self.content:create( parentFrame )
    end

    local text = self.owner.colorizer and self.owner.colorizer( self.tag ) or self.tag
    self.label:setLabel( text )
end
