--
-- Zlodo's UI framework
-- Author: Zlodo (Taliriah-Silvermoon EU)
--
-- A widget representing a tag in the tag selector.
--
local _, addon = ...
addon.zu = addon.zu or {}
local zu = addon.zu

local TagSelectorItemClass = {}
zu.TagSelectorItemClass = TagSelectorItemClass
setmetatable( TagSelectorItemClass, { __index = zu.CompositeClass } )

function TagSelectorItemClass:new( tpl )
    local o = {}
    setmetatable( tpl, { __index = self } )
    setmetatable( o, { __index = tpl } )
    return o
end

local checkboxTpl =
{
    innerMargin = 4
}

local emptyTpl = {}

function TagSelectorItemClass:create( parentFrame )
    if not self.content then
        self.cb = zu.CheckBox( checkboxTpl )

        self.cb.onClick = function( checked )
            if checked then
                self.owner.outputModel:add( self.tag )
            else
                self.owner.outputModel:remove( self.tag )
            end
        end

        self.content = zu.Minimize( emptyTpl )
        self.content.content = self.cb

        self.content.parent = self
        self.content:create( parentFrame )
    end

    local text = self.owner.colorizer and self.owner.colorizer( self.tag ) or self.tag
    self.cb:setLabel( text )

    local checked = false
    if self.owner.outputModel then
        checked = self.owner.outputModel:contains( self.tag )
    end
    self.cb:setChecked( checked )
end

function TagSelectorItemClass:calcMinMax()
    zu.CompositeClass.calcMinMax( self )
    self.maxWidth = nil
end
